#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define fi first
#define se second
mt19937_64 rnd(chrono::steady_clock().now().time_since_epoch().count());

struct mst {

    mst() {}
    mst(vector<int> a) {
        n = a.size();
        v.resize(n * 4);
        build(a, 0, 0, n - 1);
    }

    void build(vector<int>& a, int pos, int l, int r) {
        if (l == r) {
            v[pos] = {a[l]};
            return;
        }
        int m = (l + r) / 2;
        build(a, pos * 2 + 1, l, m);
        build(a, pos * 2 + 2, m + 1, r);

        merge(all(v[pos * 2 + 1]), all(v[pos * 2 + 2]), back_inserter(v[pos]));
    }

    int less_equal(int l, int r, int x, int pos, int tl, int tr) {
        if (r < tl || tr < l) return 0;
        if (l <= tl && tr <= r) {
            return upper_bound(all(v[pos]), x) - v[pos].begin();
        }
        int m = (tl + tr) / 2;
        return less_equal(l, r, x, pos * 2 + 1, tl, m) + less_equal(l, r, x, pos * 2 + 2, m + 1, tr);
    }

    int n;
    vector<vector<int>> v;

};

struct WaveletTree {
    int lo, hi;
    WaveletTree *l = nullptr;
    WaveletTree *r = nullptr;
    vector<int> cnt;

    WaveletTree() {}
    WaveletTree(vector<int>::iterator lb, vector<int>:: iterator rb, int x, int y) {
        lo = x, hi = y;
        if (lo + 1 == hi) return;

        int mid = (lo + hi) / 2;
        auto f =[&](int x) {
            return x < mid;
        };

        cnt.reserve(rb - lb + 1);
        cnt.push_back(0);
        for (auto it = lb; it != rb; it++) cnt.push_back(cnt.back() + f(*it));

        auto bound = stable_partition(lb, rb, f);
        if (lb != bound) l = new WaveletTree(lb, bound, x, mid);
        if (bound != rb) r = new WaveletTree(bound, rb, mid, y);
    }

    int kth(int lq, int rq, int k) {
        if (lo + 1 == hi) return lo;

        int lb = cnt[lq - 1];
        int rb = cnt[rq];
        int to_left = rb - lb;
        if (k <= to_left) {
            return l->kth(lb + 1, rb, k);
        } else {
            return r->kth(lq - lb, rq - rb, k - to_left);
        }
    }
};

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n, q, k;
    cin >> n >> q >> k;
    k--;

    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        v[i]--;
    }

    vector<pair<int, int>> qr(q);
    for (int i = 0; i < q; i++) {
        cin >> qr[i].first >> qr[i].second;
        qr[i].first--, qr[i].second--;
    }

    vector<int> c = v;
    WaveletTree wt(all(c), 0, n);

    vector<int> rev(n);
    for (int i = 0; i < n; i++) {
        rev[v[i]] = i;
    }

    for (int i = q - 1; i >= 0; i--) {
        auto [l, r] = qr[i];
        if (k < l || r < k) continue;
//        int t = ms.less_equal(0, r - l, v[k - l], 0, 0, n - 1);
        int t = wt.kth(1, r - l + 1, k - l + 1);
//        cout << i << ": " << t << "\n";
        t = rev[t];
//        cout << i << ": " << t << "\n";
//        assert(t < r - l + 1);
        k = l + t;
//        cout << i << ": k = " << k << "\n";
    }

    cout << k + 1;

}