#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define len(x) (int)x.size()
#define all(x) x.begin(), x.end()

using namespace std;

//#define int ll
#define ss second
#define ff first


const ll mod1 = 1e9 + 7;
const ll mod2 = 998224353;

struct hash{

    ll res1;
    ll res2;

    hash(){

    }

    hash(int a, int b){
        res1 = a % mod1;
        res2 = b % mod2;
    }

    void operator+(hash oth){
        res1 = (res1 + oth.res1) % mod1;
        res2 = (res2 + oth.res2) % mod2;
    }

    void operator*(hash oth){
        res1 = (oth.res1 * res1) % mod1;
        res2 = (oth.res2 * res2) % mod2;
    }

    void operator-(hash oth){
        res1 = (res1 - oth.res1 + mod1) % mod1;
        res2 = (res2 - oth.res2 + mod2) % mod2;
    }

};

struct tree{

    int n;
    vector<ll> t;
    vector<int> a;

    ll mrg(ll a, ll b){
        return a + b;
    }

    void build(int v, int l, int r){
        if(l + 1 == r){
            t[v] = a[l];
            return;
        }
        int mid = (l + r) / 2;
        build(2 * v + 1, l, mid);
        build(2 * v + 2, mid, r);
        t[v] = mrg(t[2 * v + 1], t[2 * v + 2]);
    }

    tree(vector<int> &b){
        a = b;
        n = len(a);
        t.resize(4 * n);
        build(0, 0, n);
    }

    ll get(int v, int vl, int vr, int ql, int qr){
        if(qr <= vl || vr <= ql){
            return 0;
        }
        if(ql <= vl && vr <= qr){
            return t[v];
        }
        int mid = (vl + vr) / 2;
        return mrg(get(2 * v + 1, vl, mid, ql, qr), get(2 * v + 2, mid, vr, ql, qr));
    }

    ll get(int l, int r){
        return get(0, 0, n, l, r);
    }

};

vector<set<int>> g;
vector<int> ans;

bool dfs(int cur){
    while(len(g[cur])){
        auto nxt = *g[cur].begin();
        g[cur].erase(nxt);
        g[nxt].erase(cur);
        if(dfs(nxt)) {
            ans.push_back(cur);
            return true;
        }
    }
    ans.push_back(cur);
    return true;
}

void solve(){
    int n, m, k;
    cin >> n >> m >> k;
    map<pair<int, int>, int> mp;
    for(int i = 0; i < m; ++i){
        int u, v;
        cin >> u >> v;
        if(u > v) swap(u, v);
        mp[{u, v}]++;
    }
    for(int i = 0; i < k; ++i){
        int u, v;
        cin >> u >> v;
        if(u > v) swap(u, v);
        mp[{u, v}]--;
    }
    g.resize(n);
    for(auto [x, cnt] : mp){
        if(cnt != 0){
            g[x.first - 1].insert(x.second - 1);
            g[x.second - 1].insert(x.first - 1);
        }
    }
    for(int i = 0; i < n; ++i){
        if(len(g[i]) % 2 == 1){
            cout << "NO\n";
            return;
        }
    }
    vector<vector<int>> answer;
    for(int i = 0; i < n; ++i){
        while(len(g[i]) > 0){
            ans.clear();
            dfs(i);
            for(int j = 2; j < len(ans) - 1; ++j){
                answer.push_back({ans[0] + 1, ans[j - 1] + 1, ans[j] + 1});
            }
        }
    }
    cout << "YES\n";
    cout << len(answer) << '\n';
    for(auto x : answer) {
        for(auto y : x){
            cout << y << ' ';
        }
        cout << '\n';
    }
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
}
