#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define len(x) (int)x.size()
#define all(x) x.begin(), x.end()

using namespace std;

//#define int ll
#define ss second
#define ff first


const ll mod1 = 1e9 + 7;
const ll mod2 = 998224353;

struct hash{

    ll res1;
    ll res2;

    hash(){

    }

    hash(int a, int b){
        res1 = a % mod1;
        res2 = b % mod2;
    }

    void operator+(hash oth){
        res1 = (res1 + oth.res1) % mod1;
        res2 = (res2 + oth.res2) % mod2;
    }

    void operator*(hash oth){
        res1 = (oth.res1 * res1) % mod1;
        res2 = (oth.res2 * res2) % mod2;
    }

    void operator-(hash oth){
        res1 = (res1 - oth.res1 + mod1) % mod1;
        res2 = (res2 - oth.res2 + mod2) % mod2;
    }

};

struct tree{

    int n;
    vector<ll> t;
    vector<int> a;

    ll mrg(ll a, ll b){
        return a + b;
    }

    void build(int v, int l, int r){
        if(l + 1 == r){
            t[v] = a[l];
            return;
        }
        int mid = (l + r) / 2;
        build(2 * v + 1, l, mid);
        build(2 * v + 2, mid, r);
        t[v] = mrg(t[2 * v + 1], t[2 * v + 2]);
    }

    tree(vector<int> &b){
        a = b;
        n = len(a);
        t.resize(4 * n);
        build(0, 0, n);
    }

    ll get(int v, int vl, int vr, int ql, int qr){
        if(qr <= vl || vr <= ql){
            return 0;
        }
        if(ql <= vl && vr <= qr){
            return t[v];
        }
        int mid = (vl + vr) / 2;
        return mrg(get(2 * v + 1, vl, mid, ql, qr), get(2 * v + 2, mid, vr, ql, qr));
    }

    ll get(int l, int r){
        return get(0, 0, n, l, r);
    }

};

vector<int> getleft(vector<int> &a){
    int n = len(a);
    deque<pair<int, int>> q;
    vector<int> ans(n, -1);
    for(int i = 0; i < n; ++i){
        while(len(q) && q.back().first < a[i]){
            q.pop_back();
        }
        if(len(q)) ans[i] = q.back().second;
        q.push_back({a[i], i});
    }
    return ans;
}

vector<int> getright(vector<int> &a){
    int n = len(a);
    deque<pair<int, int>> q;
    vector<int> ans(n, n);
    for(int i = n - 1; i >= 0; --i){
        while(len(q) && q.back().first < a[i]){
            q.pop_back();
        }
        if(len(q)) ans[i] = q.back().second;
        q.push_back({a[i], i});
    }
    return ans;
}

void solve(){
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> c(n);
    for(int i = 0; i < n; ++i){
        cin >> a[i];
    }
    for(int i = 0; i < n; ++i){
        cin >> c[i];
    }
    vector<int> le = getleft(a);
    vector<int> ri = getright(a);
    vector<ll> dp(n + 1, 1e18);
    multiset<pair<ll, int>> st;
    multiset<pair<int, ll>> st2;
    dp[0] = 0;
    for(int i = 0; i < n; ++i){
        int j = le[i];
        if(j == -1){
            dp[i + 1] = c[i];
        }
        else{
            dp[i + 1] = dp[j + 1] + c[i];
        }
        while(len(st2) && (*st2.begin()).first == i){
            st.extract({(*st2.begin()).second , (*st2.begin()).first});
            st2.extract(st2.begin());
        }
        if(len(st)){
            auto x = *st.begin();
            dp[i + 1] = min(dp[i + 1], x.first);
        }
        st.insert({dp[i] + c[i], ri[i]});
        st2.insert({ri[i], dp[i] + c[i]});
    }
    cout << dp[n] << '\n';
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.precision(10);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
}
