#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define len(x) (int)x.size()
#define all(x) x.begin(), x.end()

using namespace std;

//#define int ll
#define ss second
#define ff first


const ll mod1 = 1e9 + 7;
const ll mod2 = 998224353;

struct hash{

    ll res1;
    ll res2;

    hash(){

    }

    hash(int a, int b){
        res1 = a % mod1;
        res2 = b % mod2;
    }

    void operator+(hash oth){
        res1 = (res1 + oth.res1) % mod1;
        res2 = (res2 + oth.res2) % mod2;
    }

    void operator*(hash oth){
        res1 = (oth.res1 * res1) % mod1;
        res2 = (oth.res2 * res2) % mod2;
    }

    void operator-(hash oth){
        res1 = (res1 - oth.res1 + mod1) % mod1;
        res2 = (res2 - oth.res2 + mod2) % mod2;
    }

};

struct tree{

    int n;
    vector<ll> t;
    vector<int> a;

    ll mrg(ll a, ll b){
        return a + b;
    }

    void build(int v, int l, int r){
        if(l + 1 == r){
            t[v] = a[l];
            return;
        }
        int mid = (l + r) / 2;
        build(2 * v + 1, l, mid);
        build(2 * v + 2, mid, r);
        t[v] = mrg(t[2 * v + 1], t[2 * v + 2]);
    }

    tree(vector<int> &b){
        a = b;
        n = len(a);
        t.resize(4 * n);
        build(0, 0, n);
    }

    ll get(int v, int vl, int vr, int ql, int qr){
        if(qr <= vl || vr <= ql){
            return 0;
        }
        if(ql <= vl && vr <= qr){
            return t[v];
        }
        int mid = (vl + vr) / 2;
        return mrg(get(2 * v + 1, vl, mid, ql, qr), get(2 * v + 2, mid, vr, ql, qr));
    }

    ll get(int l, int r){
        return get(0, 0, n, l, r);
    }

};

ld fs(ld a, int x){
    if (x == 0) return 1;
    ld p = fs(a, x / 2);
    if (x % 2) return a * p * p;
    return p * p;
}

struct event{
    int pos;
    int tp;
    int ind;
    event(int p, int t, int i) : pos(p), tp(t), ind(i){}
};

ld r;

void solve(){
    int n, m;
    cin >> n >> m;
    cin >> r;

    vector<event> evs;
    vector<int> w(n);
    vector<ld> ans(m);

    int xx;
    for (int i = 0; i < n; ++i){
        cin >> xx >> w[i];
        evs.emplace_back(xx, 1, i);
    }
    for (int i = 0; i < m; ++i){
        cin >> xx;
        evs.emplace_back(xx, 0, i);
    }

    sort(all(evs), [&](event a, event b){
        if (a.pos == b.pos) return a.tp > b.tp;
        return a.pos < b.pos;
    });

    ld x = 0;
    int ls = 0;
    for (int i = 0; i < evs.size(); ++i){
        x = x * fs(1 - r, evs[i].pos - ls);
        if (evs[i].tp) x += r * w[evs[i].ind];
        else ans[evs[i].ind] = x;
        ls = evs[i].pos;
    }

    for (int i = 0; i < m; ++i) cout << ans[i] << ' ';
    cout << '\n';


}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.precision(10);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
}
