#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define len(x) (int)x.size()
#define all(x) x.begin(), x.end()

using namespace std;

#define int ll
#define ss second
#define ff first


const ll mod1 = 1e9 + 7;
const ll mod2 = 998224353;

struct hash{

    ll res1;
    ll res2;

    hash(){

    }

    hash(int a, int b){
        res1 = a % mod1;
        res2 = b % mod2;
    }

    void operator+(hash oth){
        res1 = (res1 + oth.res1) % mod1;
        res2 = (res2 + oth.res2) % mod2;
    }

    void operator*(hash oth){
        res1 = (oth.res1 * res1) % mod1;
        res2 = (oth.res2 * res2) % mod2;
    }

    void operator-(hash oth){
        res1 = (res1 - oth.res1 + mod1) % mod1;
        res2 = (res2 - oth.res2 + mod2) % mod2;
    }

};

struct tree{

    int n;
    vector<ll> t;
    vector<int> a;

    ll mrg(ll a, ll b){
        return a + b;
    }

    void build(int v, int l, int r){
        if(l + 1 == r){
            t[v] = a[l];
            return;
        }
        int mid = (l + r) / 2;
        build(2 * v + 1, l, mid);
        build(2 * v + 2, mid, r);
        t[v] = mrg(t[2 * v + 1], t[2 * v + 2]);
    }

    tree(vector<int> &b){
        a = b;
        n = len(a);
        t.resize(4 * n);
        build(0, 0, n);
    }

    ll get(int v, int vl, int vr, int ql, int qr){
        if(qr <= vl || vr <= ql){
            return 0;
        }
        if(ql <= vl && vr <= qr){
            return t[v];
        }
        int mid = (vl + vr) / 2;
        return mrg(get(2 * v + 1, vl, mid, ql, qr), get(2 * v + 2, mid, vr, ql, qr));
    }

    ll get(int l, int r){
        return get(0, 0, n, l, r);
    }

};

ll n;
int k;
set<ll> a;
multiset<pair<ll, ll>> b;

void add(ll i, ll j){
    if (i == -1) b.insert({j, 0});
    else if (j == n) b.insert({n - i - 1, -n + 1});
    else b.insert({(j - i) / 2, -((j + i) / 2)});
}
void del(ll i, ll j){
    if (i == -1) b.erase(b.find({j, 0}));
    else if (j == n) b.erase(b.find({n - i - 1, -n + 1}));
    else b.erase(b.find({(j - i) / 2, -((j + i) / 2)}));
}

void solve(){
    cin >> n >> k;

    a.insert(-1);
    a.insert(n);
    add(-1, n);

    vector<int> inds;

    char cc;
    ll x;
    for (int uu = 0; uu < k; uu++){
        cin >> cc;
        if (cc == '+'){
            pair<ll, ll> ans = *(--b.end());
            ll ind = ans.ss;
            cout << -ind + 1 << '\n';

            inds.push_back(-ind);
            a.insert(-ind);
            const auto it = a.find(-ind);
            auto pr = --a.find(-ind);
            auto nx = ++a.find(-ind);

            del(*pr, *nx);
            add(*it, *nx);
            add(*pr, *it);
        }
        else {
            cin >> x;
            x = inds[x - 1];
            auto it = a.find(x);
            auto pr = --a.find(x);
            auto nx = ++a.find(x);

            del(*it, *nx);
            del(*pr, *it);
            add(*pr, *nx);

            a.erase(it);
        }
    }
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
}