#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <math.h>
using namespace std;
#define int long long
#define pii pair<int, int>
#define vec vector

void imin(int& a, int b) {a = min(a, b);}

int inf = 1000000005;

struct DisjointSparseTable {
    int ff(int e, int p = -inf) {return max(e, p);}
    vec<vec<int>> st;
    vec<int> logs;
    void build(vec<int> a, int n) {
        int len = 1;
        while((1ll << len) < n) len++;
        a.resize((1ll << len), 0);
        logs.resize((1ll << len), 0);
        st = vec<vec<int>> (len + 1, vec<int>(1ll << len));
        st[0][0] = a[0];
        for(int i = 1; i < (1ll << len); i++) {
            logs[i] = log2(i);
            st[0][i] = ff(a[i]);
        }
        for(int h = 1; h < len; h++) {
            int tlen = (1ll << h);
            for(int c = tlen; c < (1ll << len); c += 2 * tlen) {
                st[h][c] = a[c];
                for(int i = c + 1; i < c + tlen; i++) {
                    st[h][i] = ff(st[h][i - 1], a[i]);
                }
                st[h][c - 1] = a[c - 1];
                for(int i = c- 2; i >= c - tlen; i--) {
                    st[h][i] = ff(st[h][i + 1], a[i]);
                }
            }
        }
    }
    int ans(int l, int r) {
        if(l == r) return ff(st[0][l]);
        int row = logs[l ^ r];
        return ff(st[row][l], st[row][r]);
    }
};


signed main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n; cin >> n;
    vec<int> h(n), c(n);
    for(int &i : h) cin >> i;
    for(int &i : c) cin >> i;
    DisjointSparseTable disp;
    disp.build(h, n);
    vec<int> dp(n);
    dp[0] = c[0];
    for(int i = 1; i < n; i++) {
        dp[i] = c[i] + dp[i - 1];
        for(int j = 0; j < i; j++) {
            if(disp.ans(j + 1, i) == h[i]) {
                imin(dp[i], dp[j] + c[i]);
            }
        }
        if(disp.ans(0, i) == h[i]) {
            imin(dp[i], c[i]);
        }
        for(int j = 1; j < i; j++) {
            if(disp.ans(j, i) == h[j]) {
                imin(dp[i], dp[j - 1] + c[j]);
            }
        }
    }
    cout << dp[n - 1];

}