#include <bits/stdc++.h>

using namespace std;

const int N = 1e5 + 7;
unordered_set <int> g[N];
unordered_set <int> non_empty;
bool visited[N];
int par[N];
vector <int> cur;
vector <int> cycle;

bool dfs(int v, int p) {
    visited[v] = 1;
    par[v] = p;
    cur.push_back(v);
    for (int u : g[v]) {
        if (u == p) {
            continue;
        }
        if (visited[u]) {
            cycle.push_back(u);
            int curv = v;
            while (curv != u) {
                cycle.push_back(curv);
                curv = par[curv];
            }
            return true;
        }
        if (!visited[u]) {
            if (dfs(u, v)) {
                return true;
            }
        }
    }
    return false;
}

void invert(int u, int v) {
    if (g[u].find(v) != g[u].end()) {
        g[u].erase(v);
        g[v].erase(u);
        if (g[u].empty()) {
            non_empty.erase(u);
        }
        if (g[v].empty()) {
            non_empty.erase(v);
        }
    } else {
        g[u].insert(v);
        g[v].insert(u);
        non_empty.insert(u);
        non_empty.insert(v);
    }
}

void invert(int a, int b, int c) {
    invert(a, b);
    invert(b, c);
    invert(a, c);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    memset(visited, 0, sizeof(visited));
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < m + k; i++) {
        int v, u;
        cin >> v >> u;
        invert(v, u);
    }
    vector <tuple <int, int, int>> ans;
    while (!non_empty.empty()) {
        int v = *non_empty.begin();
        cur.clear();
        cycle.clear();
        if (!dfs(v, -1)) {
            cout << "NO\n";
            return 0;
        }
        for (int i = 0; i + 2 < (int) cycle.size(); i++) {
            // invert(cycle[0], cycle[i + 1], cycle[i + 2]);
            ans.emplace_back(cycle[0], cycle[i + 1], cycle[i + 2]);
        }
        for (int i = 0; i < (int) cycle.size(); i++) {
            int nxt = (i + 1) % cycle.size();
            invert(cycle[i], cycle[nxt]);
        }
        for (int u : cur) {
            visited[u] = false;
        }
    }
    cout << "YES\n";
    cout << ans.size() << '\n';
    for (auto [a, b, c] : ans) {
        cout << a << ' ' << b << ' ' << c << '\n';
    }
    return 0;
}