import random

MAX = 10 ** 9


def gen_st(h):
    n = 2 ** h - 1
    t = [0] * n
    used = {}
    for i in range(n // 2, n):
        cur = random.randint(1, MAX)
        while used.get(cur, False):
            cur = (cur % MAX) + 1
        used[cur] = True
        t[i] = cur
    for i in range(n // 2 - 1, -1, -1):
        t[i] = min(t[2 * i + 1], t[2 * i + 2])
    return t


def try_build(n, a):
    h = 1
    while 2 ** h < n:
        h += 1

    cnt = {}
    for x in a:
        if x not in cnt:
            cnt[x] = 0
        cnt[x] += 1

    p = []
    for x, y in cnt.items():
        p.append((x, y))

    p = sorted(p, key=lambda p: (-p[1], p[0]))

    bad = False
    t = [0] * n

    if not bad:
        id = 0
        for i in range(h):
            pos = []
            if i == 0:
                pos = [(0, 0)]
            else:
                for j in range(2 ** (i - 1)):
                    cur = 2 ** i + 2 * j
                    pos.append((t[cur - 1], cur))
            pos = sorted(pos)
            # print(pos)

            for _, cur_pos in pos:
                v = cur_pos
                x, y = p[id]
                id += 1
                while v < n:
                    t[v] = x
                    v = 2 * v + 1
                    y -= 1
                # print(x, y, t)
                if y != 0:
                    bad = True
                    break

    for i in range(1, n):
        bad |= t[i] < t[(i - 1) // 2]

    return bad, t


def solve(n, a):
    bad, t = try_build(n, a)
    if bad:
        print(-1)
    else:
        for i in range(n // 2, n):
            print(t[i], end=' ')
        print()


def stress(h, cnt):
    n = 2 ** h - 1
    random.seed('gshark')
    for i in range(1, cnt + 1):
        a = gen_st(h)
        bad, t = try_build(n, a)
        for v in range(n // 2):
            bad |= (t[v] != min(t[2 * v + 1], t[2 * v + 2]))
        if bad:
            print('Counter test found!')
            print(n)
            print(a)
            exit(0)
        if i % 100 == 0:
            print(i, 'of', cnt, 'for h =', h)

# for h in range(12, 20):
#     stress(h, 10 ** 3)


def main():
    n = int(input())
    a = list(map(int, input().split()))
    solve(n, a)


main()
