//  Nikita Golikov, 2023

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
  #include "/Users/golikovnik/contests/debug.h"
#else
  #define debug(...) ;
#endif

template <class A, class B>
bool smin(A& x, B&& y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A& x, B&& y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

vector<pair<int, int>> D;
map<pair<int, int>, int> D_to_i;
int P;
int S;
vector<int> goodMasks;
vector<int> idMask;
struct Trans {
  int dx;
  int dy;
  int mask;
};
vector<vector<Trans>> go;

void precalc() {
  int const SIZE = 4;
  int minDX = 0;
  int maxDX = 0;
  int minDY = 0;
  int maxDY = 0;
  for (int dx = 0; dx < SIZE; ++dx) {
    for (int dy = -(SIZE - 1); dy < SIZE; ++dy) {
      if (abs(dx) + abs(dy) < SIZE && (dx > 0 || dy >= 0)) {
        D.emplace_back(dx, dy);
        smin(minDX, dx);
        smax(maxDX, dx);
        smin(minDY, dy);
        smax(maxDY, dy);
        D_to_i[{dx, dy}] = int(D.size()) - 1;
      }
    }
  }
  P = int(D.size());
  vector<int> DX{1, 0, -1, 0};
  vector<int> DY{0, 1, 0, -1};
  for (int msk = 0; msk < (1 << P); ++msk) {
    if (__builtin_popcount(msk) != SIZE) {
      continue;
    }
    if (!(msk & 1)) {
      continue;
    }
    vector used(maxDX - minDX + 1, vector<bool>(maxDY - minDY + 1));
    int ar = -1;
    int ac = -1;
    for (int i = 0; i < P; ++i) {
      if (msk >> i & 1) {
        ar = D[i].first - minDX;
        ac = D[i].second - minDY;
        used[ar][ac] = 1;
      }
    }

    int cnt = 0;
    auto dfs = [&](auto self, int r, int c) -> void {
      used[r][c] = 0;
      cnt++;
      for (int i = 0; i < 4; ++i) {
        int rr = r + DX[i];
        int cc = c + DY[i];
        if (rr >= 0 && rr <= maxDX - minDX && cc >= 0 && cc <= maxDY - minDY && used[rr][cc]) {
          self(self, rr, cc);
        }
      }
    };

    dfs(dfs, ar, ac);
    if (cnt == SIZE) {
      goodMasks.push_back(msk);
    }
  }
  S = int(goodMasks.size());
  debug(S);
  idMask.assign(1 << P, -1);
  for (int i = 0; i < S; ++i) {
    idMask[goodMasks[i]] = i;
  }

  auto makeTrans = [&](vector<pair<int, int>> a) {
    sort(a.begin(), a.end());
    a.erase(unique(a.begin(), a.end()), a.end());
    if (int(a.size()) != SIZE) {
      return Trans{-1, -1, -1};
    }
    auto[xmin, ymin] = a[0];
    int msk = 0;
    for (auto[x, y] : a) {
      x -= xmin;
      y -= ymin;
      if (!D_to_i.count({x, y})) {
        return Trans{-1, -1, -1};
      }
      msk |= 1 << D_to_i[{x, y}];
    }
    return Trans{xmin, ymin, idMask[msk]};
  };

  go.resize(S);
  int ntrans = 0;
  for (int i = 0; i < S; ++i) {
    vector<pair<int, int>> here;
    for (int j = 0; j < P; ++j) {
      if (goodMasks[i] >> j & 1) {
        here.push_back(D[j]);
      }
    }
    for (int who = 0; who < SIZE; ++who) {
      for (int dx = -1; dx <= 1; ++dx) {
        for (int dy = -1; dy <= 1; ++dy) {
          if (dx == 0 && dy == 0) {
            continue;
          }
          auto nhere = here;
          nhere[who] = {here[who].first + dx, here[who].second + dy};
          auto res = makeTrans(nhere);
          if (res.mask != -1) {
            go[i].push_back(res);
            ntrans++;
          }
        }
      }
    }
  }
  debug(ntrans);
  /*for (int it = 0; it < S; ++it) {
    for (auto tr : go[it]) {
      int const n = maxDX - minDX + 1 + 2;
      int const m = maxDY - minDY + 1 + 2;
      vector used(n, vector<int>(m));
      for (int j = 0; j < P; ++j) {
        if (goodMasks[it] >> j & 1) {
          auto[x, y] = D[j];
          used[x - (minDX - 1)][y - (minDY - 1)] |= 1;
        }
        if (goodMasks[tr.mask] >> j & 1) {
          auto[x, y] = D[j];
          x += tr.dx;
          y += tr.dy;
          used[x - (minDX - 1)][y - (minDY - 1)] |= 2;
        }
      }
      for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
          if (used[i][j] == 0) {
            cout << '.';
          } else if (used[i][j] == 1) {
            cout << 'S';
          } else if (used[i][j] == 2) {
            cout << 'T';
          } else {
            cout << '#';
          }
        }
        cout << '\n';
      }
      cout << '\n';
    }
  }*/
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  precalc();

  int n, m;
  cin >> n >> m;
  vector<string> field(n);
  for (auto& s : field) {
    cin >> s;
  }
  auto ok = [&](int i, int j) {
    return i >= 0 && i < n && j >= 0 && j < m && field[i][j] == '.';
  };
  vector okState(n, vector(m, vector<int>(S, 1)));
  for (int r = 0; r < n; ++r) {
    for (int c = 0; c < m; ++c) {
      for (int st = 0; st < S; ++st) {
        int msk = goodMasks[st];
        for (int i = 0; i < P; ++i) {
          if (msk >> i & 1) {
            okState[r][c][st] &= ok(r + D[i].first, c + D[i].second);
          }
        }
      }
    }
  }
  int initState = 0;
  for (int x = 0; x < 2; ++x) {
    for (int y = 0; y < 2; ++y) {
      assert(D_to_i.count({x, y}));
      initState |= 1 << D_to_i[{x, y}];
    }
  }
  initState = idMask[initState];
  assert(initState >= 0 && initState < S);
  assert(n >= 2 && m >= 2 && okState[0][0][initState] && okState[n - 2][m - 2][initState]);
  vector dist(n, vector(m, vector<int>(S, -1)));
  dist[0][0][initState] = 0;
  auto dfs = [&](auto self, int r, int c, int i) -> void {
    for (auto tr : go[i]) {
      int rr = r + tr.dx;
      int cc = c + tr.dy;
      if (ok(rr, cc) && okState[rr][cc][tr.mask]) {
        if (dist[rr][cc][tr.mask] < 0) {
          dist[rr][cc][tr.mask] = dist[r][c][i] + 1;
          self(self, rr, cc, tr.mask);
        }
      }
    }
  };
  dfs(dfs, 0, 0, initState);
  cout << dist[n - 2][m - 2][initState] << '\n';

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
