/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;
typedef pair<int, double> pid;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

double power(double value, int d) {
    if (d == 0) return 1.0;
    if (d == 1) return value;
    double root = power(value, d / 2);
    double result = root * root;
    if (d % 2) result *= value;
    return result;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    in(int, n, m)
    in(double, r)
    vector<pid> days(n);
    for (int i = 0; i < n; i++) {
        cin >> days[i].first >> days[i].second;
        days[i].second *= r;
    }
    sort(all(days));
    for (int i = 1; i < n; i++) {
        days[i].second += days[i - 1].second * power(1 - r, days[i].first - days[i - 1].first);
    }

    cout.precision(12);
    for (int i = 0; i < m; i++) {
        in(int, q)
        int d = -1;
        while (d + 1 < n && days[d + 1].first <= q) d++;
        if (d == -1) {
            cout << 0 << ' ';
        } else {
            cout << days[d].second * power(1 - r, q - days[d].first) << ' ';
        }
    }
    cout << '\n';

}